"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const BreakingChangeError_1 = require("./BreakingChangeError");
class ModulesBreakingChangeError extends BreakingChangeError_1.default {
    constructor(opts) {
        super({
            additionalInformation: opts.additionalInformation,
            code: 'MODULES_BREAKING_CHANGE',
            message: `The node_modules structure at ${opts.modulesPath} was changed. Try running the same command with the --force parameter.`,
            relatedIssue: opts.relatedIssue,
            relatedPR: opts.relatedPR,
        });
        this.modulesPath = opts.modulesPath;
    }
}
exports.default = ModulesBreakingChangeError;
//# sourceMappingURL=ModulesBreakingChangeError.js.map